module	cheban_top
		(clk,
		reset_n,
		rs232_rx_in,
		che_moto_ctrl,
		jixiebi_moto_one,
		jixiebi_moto_two,
		tishengmoto,
		RCServo_pulse,
		jidianqi_ctrl,
		dcmoto_pwm,
		u3_1oe,
		u3_1dir,
		u3_2oe,
		u3_2dir,
		u5_1oe,
		u5_1dir,
		u5_2oe,
		u5_2dir
		);
input	clk;
input	reset_n;
input	rs232_rx_in;
output	[3:0]	che_moto_ctrl[3:0];		//˶ƶ
output	[1:0] jixiebi_moto_one;			//е۵һתؽڵƶ
output	[1:0] jixiebi_moto_two;			//е۵ڶתؽڵƶ
output	[1:0] tishengmoto;				//ƶ
output	RCServo_pulse;					//PWMź
output	jidianqi_ctrl;					//ſƶ
output	[7:0] dcmoto_pwm;				//ֱ綯PWMź

output	u3_1oe;
output	u3_1dir;
output	u3_2oe;
output	u3_2dir;
output	u5_1oe;
output	u5_1dir;
output	u5_2oe;
output	u5_2dir;

////////////////////////////////////////////////////////////////////////
////
assign u3_1oe	=	1'b0;
assign	u3_1dir	=	1'b1;
assign	u3_2oe	=	1'b0;
assign	u3_2dir	=	1'b1;
assign u5_1oe	=	1'b0;
assign	u5_1dir	=	1'b1;
assign	u5_2oe	=	1'b0;
assign	u5_2dir	=	1'b1;


wire	[15:0] rx_data_out;
wire	rx_data_en;
uart_rx_top	u0(
		.clk(clk),
		.rs232_rx_in(rs232_rx_in),
		.rx_data_en(rx_data_en),
		.rx_data_out(rx_data_out[15:0]),
		.reset_n(reset_n)
		);
///////////////////////////////////////////////////////////////////////
////ʹź½ضȡ
reg uart_out_temp2;
reg	uart_out_temp1;	
always@(posedge clk)
	begin
		uart_out_temp1	<=	rx_data_en;
		uart_out_temp2	<=	uart_out_temp1;
	end
assign	uart_rx_negedge = uart_out_temp2&(!uart_out_temp1);
///////////////////////////////////////////////////////////////////////
////ȡ̵ײ˶תɵĿźš////////////
////ʵֵתתת		//////////////////////////
reg	[3:0]	che_moto_ctrl;
always@(posedge	clk )
	if(uart_rx_negedge)
	begin
		if(rx_data_out[5:2]==4'b1110)		//˶ת-----ǰ,״̬0ΪЧ
		begin
			che_moto_ctrl[3:0]	<=	4'b1010;	
		end
		if(rx_data_out[5:2]==4'b1101)		//ת-----,״̬0ΪЧ
		begin
			che_moto_ctrl[3:0]	<=	4'b0101;	
		end
		if(rx_data_out[5:2]==4'b1011)		//һһת-----ת,״̬0ΪЧ
		begin
			che_moto_ctrl[3:0]	<=	4'b1001;
		end
		if(rx_data_out[5:2]==4'b0111)		//һһת-----ת,״̬0ΪЧ
		begin
			che_moto_ctrl[3:0]	<=	4'b0110;
		end
		if(rx_data_out[5:2]==4'b1111)		//ް£ֹͣ2ת
		begin
			che_moto_ctrl[3:0]	<=	4'b1111;
		end
	end
////////////////////////////////////////////////////////////////////////////
///е۵һؽת
////////////////////////////////////////////////////////////////////////////
reg	[1:0] jixiebi_moto_one;
always@(posedge	clk)
	if(uart_rx_negedge)
	begin
			if(rx_data_out[7:6]==2'b10)		//ת
			begin
				jixiebi_moto_one[1:0]	<=	2'b10;
			end
			if(rx_data_out[7:6]==2'b01)		//ת
			begin
				jixiebi_moto_one[1:0]	<=	2'b01;
			end
			if(rx_data_out[7:6]==2'b11)		//ͣת
			begin
				jixiebi_moto_one[1:0]	<=	2'b11;
			end
	end
	
////////////////////////////////////////////////////////////////////////////
///е۵ڶؽת
////////////////////////////////////////////////////////////////////////////
reg	[1:0] jixiebi_moto_two;
always@(posedge	clk)
	if(uart_rx_negedge)
	begin
			if(rx_data_out[9:8]==2'b10)		//ת
			begin
				jixiebi_moto_two[1:0]	<=	2'b10;
			end
			if(rx_data_out[9:8]==2'b01)		//ת
			begin
				jixiebi_moto_two[1:0]	<=	2'b01;
			end
			if(rx_data_out[9:8]==2'b11)		//ͣת
			begin
				jixiebi_moto_two[1:0]	<=	2'b11;
			end
	end
	
////////////////////////////////////////////////////////////////////////////
///и˵
////////////////////////////////////////////////////////////////////////////
reg	[1:0] tishengmoto;
always@(posedge	clk)
	if(uart_rx_negedge)
	begin
			if(rx_data_out[11:10]==2'b10)		//ת
			begin
				tishengmoto[1:0]	<=	2'b10;
			end
			if(rx_data_out[11:10]==2'b01)		//ת
			begin
				tishengmoto[1:0]	<=	2'b01;
			end
			if(rx_data_out[11:10]==2'b11)		//ͣת
			begin
				tishengmoto[1:0]	<=	2'b11;
			end
	end
/////////////////////////////////////////////////////////////////////////////
//////ӶźϿ
////////////////////////////////////////////////////////////////////////////
	sevro	u1(
			.clk(clk), 
			.sevro_ctrl(rx_data_out[13:12]),
			.data_valid(uart_rx_negedge),
			.RCServo_pulse(RCServo_pulse)
			);
			
///////////////////////////////////////////////////////////////////////////
//Ͽƣ̵ͨƵĹԴ
//ģаܣϰϣϺ󣬵һֱϡ
//ɿɿ
//////////////////////////////////////////////////////////////////////////
reg	jidianqi_ctrl;
always@(posedge clk)
	if(uart_rx_negedge)
		begin
			if(rx_data_out[15:14]==2'b01)
				jidianqi_ctrl	<=	1'b1;
			if(rx_data_out[15:14]==2'b10)
				jidianqi_ctrl	<=	1'b0;
		end
		/*
///////////////////////////////////////////////////////////////////////////
/////6·ֱ綯PWM .
/////ͨڷ͵bit0bit1е١
/////bit0ٶߣbit1ٶ½
///////////////////////////////////////////////////////////////////////////
reg	[7:0] pwm_data;
always@(posedge clk	or negedge reset_n)
	if(!reset_n)
	begin
		pwm_data	<=	8'hf0;
	end
	else
	begin
	if(uart_rx_negedge)
		case(rx_data_out[1:0])
		2'b01	:	begin
			pwm_data[7:0]	<=	pwm_data[7:0]	+	5;
		end
		2'b10	:	begin
			pwm_data[7:0]	<=	pwm_data[7:0]	-	5;
		end
		default	:	pwm_data	<=	pwm_data;
		endcase
	end
wire	[7:0] dcmoto_pwm;
	dcmoto	u2(
			.clk(clk),
			.indata(pwm_data[7:0]),
			.pwm(dcmoto_pwm[7:0])
			);
	*/
parameter dcClkDiv = 195; 
reg [7:0] dcClkCount;
reg dcClkTick;

always @(posedge clk) dcClkTick <= (dcClkCount==dcClkDiv-2);

always @(posedge clk) if(dcClkTick) dcClkCount <= 0; else dcClkCount <= dcClkCount + 1;
////////////////////////////////////////////////////////////////////////////
reg [11:0] dcPulseCount;

always @(posedge clk) if(dcClkTick) dcPulseCount <= dcPulseCount + 1;		
		
reg	[7:0] dcmoto_pwm;
always @(posedge clk) 
	begin
		if(dcPulseCount==0) dcmoto_pwm[7:0] <= 8'hff;
		if(dcPulseCount>11'hff0) dcmoto_pwm[7:0] <= 8'h00; 
	end

endmodule


	




