/*
16λڽģ
*/
module uart_rx(clk,rst_n,rs232_rx,clk_bps,bps_start,rx_data,rx_int);
input clk; // 50MHzʱ
input rst_n;  //͵ƽλź
input rs232_rx;   // RS232ź
input clk_bps;    // clk_bpsĸߵƽΪջ߷λм
output bps_start; //յݺ󣬲ʱźλ
output[15:0] rx_data; //ݼĴֱһ 
output rx_int;    //жź,յڼʼΪߵƽ
//----------------------------------------------------------------
reg rs232_rx0,rs232_rx1,rs232_rx2; //ݼĴ˲
wire neg_rs232_rx;   //ʾ߽յ½
always @ (posedge clk or negedge rst_n) begin
    if(!rst_n) begin
           rs232_rx0 <= 1'b1;
           rs232_rx1 <= 1'b1;
           rs232_rx2 <= 1'b1;
       end
    else begin
           rs232_rx0 <= rs232_rx;
           rs232_rx1 <= rs232_rx0;
           rs232_rx2 <= rs232_rx1;
       end
end
assign neg_rs232_rx = rs232_rx2 & ~rs232_rx1; //յ½غneg_rs232_rxøһʱ
//----------------------------------------------------------------
reg bps_start_r;
reg[4:0]   num;   //λ
reg rx_int;   //жź,յڼʼΪߵƽ
always @ (posedge clk or negedge rst_n) begin
    if(!rst_n) begin
           bps_start_r <= 1'bz;
           rx_int <= 1'b0;
       end
    else if(neg_rs232_rx) begin
           bps_start_r <= 1'b1; // 
           rx_int <= 1'b1;   //жźʹ
           end
    else if(num==5'd20) begin
           bps_start_r <= 1'bz; //ݽ
           rx_int <= 1'b0;      //жźŹر
       end
end 
assign bps_start = bps_start_r;
//----------------------------------------------------------------
reg  [15:0] rx_data_r;  //ݼĴֱһ
//----------------------------------------------------------------
reg  [15:0]   rx_temp_data; //ǰݼĴ
reg rx_data_shift;   //λ־
always @ (posedge clk or negedge rst_n) begin
    if(!rst_n) begin
           rx_data_shift <= 1'b0;
           rx_temp_data <= 16'd0;
           num <= 5'd0;
           rx_data_r <= 16'd0;
       end
    else if(rx_int) begin    //ݴ
			if(clk_bps) begin //ȡ,Ϊһʼλ8bitݣһλ       
              rx_data_shift <= 1'b1;
              num <= num+1'b1;
              if(num<=5'd16) rx_temp_data[15] <= rs232_rx;    //9bit1bitʼλ8bitݣ
           end
       else if(rx_data_shift) begin    //λ    
              rx_data_shift <= 1'b0;
              if(num<=5'd16) rx_temp_data <= rx_temp_data >> 1'b1;  //λ8Σ1bitʼλƳʣ8bitʱ
              else if(num==5'd20) begin
                     num <= 5'd0;  //յSTOPλ,num
                     rx_data_r <= rx_temp_data;  //浽ݼĴrx_data
                  end
           end
       end
end
assign rx_data = rx_data_r; 
endmodule